
## Please install Lavaan package if have not.
## install.packages("lavaan")

## Bain package is not on CRAN at the moment
## Please download Bain package from 
## https://informative-hypotheses.sites.uu.nl/software/bain/
## and install it from local file using following lines.
## install.packages(".../Bain_xxx.zip", repos = NULL, type = "win.binary")  ##for Windows
## install.packages(".../Bain_xxx.tgz", repos = NULL, type = "mac.binary")  ##for mac

rm(list=ls())
library(Bain)
library(lavaan)
setwd(".../Example2") ##set path where data of example 2 stored. 
performance<-read.table("example2.dat",header=TRUE)

perform.model<-'
              # measurement model
                kno =~ x11+x12
                ori =~ x21+x22
                sat =~ x31+x32
                per =~ y1+y2
              # regressions
                per ~ kno + ori + sat + tra'
fit<-sem(perform.model,data=performance,std.lv = TRUE)

##observe estimates and covariance matrix of target parameters
estimate<-standardizedSolution(fit)$est.std[9:12]
Sigma<-lavInspect(fit, "vcov.std.all")[9:12,9:12]

n<-nobs(fit)  ##sample size
p<-length(estimate)  ##number of parameters

ERr1=ERr2=ERr3=NULL
IRr1<-matrix(c(1, -1,  0,  0,  0,
               0,  1,  0, -1,  0,
               0,  0, -1,  1,  0), nrow = 3, byrow = TRUE)

IRr2<-matrix(c(1, -1,  0,  0,  0,
               0,  1, -1,  0,  0,
               0,  0,  1, -1,  0), nrow = 3, byrow = TRUE)

IRr3<-matrix(c(-1,  1,  0,  0,  0,
               0, -1,  1,  0,  0,
               0,  0, -1,  1,  0), nrow = 3, byrow = TRUE)

res<-Bain(estimate = estimate, Sigma = Sigma, grouppara = 0, jointpara = p, n = n, 
     ERr1, IRr1, ERr2, IRr2, ERr3, IRr3)

res$testResult
res$BFmatrix




